; ********** Start **********
(Defun C:POSNRWP (/ R1 R2 PKT)

  ;Systemvariablen werden gespeichert
  (Setq	DCL_ID	 (Load_Dialog "Posnrwp.dcl")
	A_FARBE	 (Getvar "cecolor")
	A_LTYP	 (Getvar "celtype")
	A_CMD	 (Getvar "cmdecho")
	A_LAY	 (Getvar "clayer")
	A_OS	 (Getvar "osmode")
	TEXTHHE 2.5
  );Setq


  (If (Null (New_Dialog "posnrwp" DCL_ID))
    (Alert
      "\nKann die Dialogboxdatei POSNRWP.DCL \n nicht finden / laden !"
    )
  );If
  
  (Setvar "cmdecho" 1)
  (DIA_ZEIG)
  (FARBZEIG)
  (LTYPZEIG)
  (POS_LAY_EINL)
  (Start_List "laylist")
  (Mapcar 'Add_List LAY_LIS)
  (End_List)
  (If (Null POSNR)
    (Setq POSNR 1)
  )
  (If TEXTHHE
    (Set_Tile "th" (Rtos TEXTHHE 2 3))
  )
  (If POSNR
    (Set_Tile "stnr" (Itoa POSNR))
  )
  (If FARBE
    (Set_Tile "farbe" FARBE)
  )
  (If LTYP
    (Set_Tile "ltype" LTYP)
  ) 
  (If (Null TYP)
    (Setq TYP 1)
  )
  (Cond
    ((= TYP 0) (Set_Tile "kreis" "1"))
    ((= TYP 1) (Set_Tile "qudr" "1"))
    ((= TYP 2) (Set_Tile "unter" "1"))
    ((= TYP 3) (Set_Tile "raute" "1"))
    ((= TYP 4) (Set_Tile "kein" "1"))
  )
  (Action_Tile "laylist" "(take-layer)")
  (Action_Tile "color" "(DONE_DIALOG 2)")
  (Action_Tile "linetype" "(DONE_DIALOG 3)")		; Steuert in entspr. Fenster aus ETSTAT
  (Action_Tile "th" "(setq texthhe (atof $value))")	; ca. 15 Zeilen nach unten
  (Action_Tile "stnr" "(setq posnr (atoi $value))")
  (Action_Tile "kreis" "(setq typ 0)")
  (Action_Tile "qudr" "(setq typ 1)")
  (Action_Tile "unter" "(setq typ 2)")
  (Action_Tile "raute" "(setq typ 3)")
  (Action_Tile "kein" "(setq typ 4)")
  (Action_Tile "winklist" "(SETQ G (ATOI (NTH (ATOI $VALUE) winklist)))")
  (Action_Tile "seg" "(SETQ seg (ATOI (NTH (ATOI $VALUE) seglist)))")
  (Action_Tile "cancel" "(DONE_DIALOG 0)")
  (Action_Tile "accept" "(done_dialog 1)")
  (Setq ETSTAT (Start_Dialog))
  (Cond
    ((= ETSTAT 0) (Unload_Dialog DCL_ID))
    ((= ETSTAT 1) (POSNR_Z))
    ((= ETSTAT 2) (Unload_Dialog DCL_ID) (DDCOLORSTART))
    ((= ETSTAT 3) (Unload_Dialog DCL_ID) (DDLTYPESTART))
    
  );Cond
  (Princ)
)


; **********  **********
(Defun POSNR_Z ()
  (If (Or (Null POSNR) (Null TEXTHHE))
    (Progn
      (Alert "\nAchtung, fehlende Werte in einem Feld !")
      (C:POSNR)
    )
    (POS_NR_MACH)
  )
  (VARREST)
)


; ********** Generiert lfd. Pos. Nr. **********
(Defun POS_NR_MACH ()
  (Setq	DIGITS	TEXTHHE
	ALT_COL	(Getvar "cecolor")
  )
  (If (Null POSNR)
    (Setq POSNR 1)
  )
  (Setvar "cecolor" FARBE)
  (Setq PKT (Getpoint "\nPunkt fr Pos-Nr.: "))
  (If PKT
    (Progn
      (Setvar "osmode" 0)
      (Command "_text" "po" "mz" PKT TEXTHHE "0" (Itoa POSNR))
      (Setq POSNR (1+ POSNR))
      (Cond
	((>= POSNR 1001) (Setq DIGITS (* TEXTHHE 2.2)))
	((>= POSNR 101) (Setq DIGITS (* TEXTHHE 1.7)))
	((>= POSNR 11) (Setq DIGITS (* TEXTHHE 1.4)))
      )
      (Cond
	((= TYP 0)
	 (Progn
	   (Command "_circle" PKT (+ (/ TEXTHHE 2) DIGITS))
	   (POS_NR_MACH)
	 )
	)
	((= TYP 1)
	 (Progn
	   (Setq R1 (Polar PKT (BM 135) (+ (/ TEXTHHE 2) DIGITS))
		 R2 (Polar PKT (BM 315) (+ (/ TEXTHHE 2) DIGITS))
	   )
	   (Command "_rectang" R1 R2)
	   (POS_NR_MACH)
	 )
	)
	((= TYP 2)
	 (Progn
	   (Setq R1 (Polar PKT (BM 225) (+ (/ TEXTHHE 2) DIGITS))
		 R2 (Polar PKT (BM 315) (+ (/ TEXTHHE 2) DIGITS))
	   )
	   (Command "_line" R1 R2 "")
	   (POS_NR_MACH)
	 )
	)
	((= TYP 3)
	 (Progn
	   (Setq R1 (Polar PKT (BM 45) (+ (/ TEXTHHE 5) DIGITS))
	   )
	   (Command "_polygon" "4" PKT "i" R1)
	   (POS_NR_MACH)
	 )
	)
	((= TYP 4)
	 (POS_NR_MACH)
	)
      )
    )
  )
  (Setvar "osmode" A_OS)
)


; ********** Variablen werden zurckgesetzt **********
(Defun VARREST ()
  (Setvar "osmode" A_OS)
  (Setvar "cecolor" A_FARBE)
  (Setvar "celtype" A_LTYP)
  (Setvar "cmdecho" A_CMD)
  (Setvar "clayer" A_LAY)
)


; **********  **********
(Defun DIA_ZEIG	(/ V1 V2)
  (Setq	V1 (Dimx_Tile "ctn")
	V2 (Dimy_Tile "ctn")
  )
  (Start_Image "ctn")
  (Fill_Image 0 0 V1 V2 -15)
  (Slide_Image 0 0 V1 V2 "ctn")
  (End_Image)
)


; ********** Layer wird gesetzt **********
(Defun TAKE-LAYER ()
  (Setq LAY-WAHL (Nth (Atoi $VALUE) LAY_LIS))
  (Setvar "clayer" LAY-WAHL)
)


; ********** Layerinformationen werden geholt **********
(Defun POS_LAY_EINL (/ LAYNAM EINTRAG)
  (Setq	LAYNAM	(Tblnext "LAYER" T)
	EINTRAG	T
	LAY_LIS	(List "0")
  ) ;_ Ende von SETQ
  (While EINTRAG
    (Setq EINTRAG (Tblnext "LAYER"))
    (If	EINTRAG
      (Setq LAYNAM  (Cdr (Assoc 2 EINTRAG))
	    LAY_LIS (Cons LAYNAM LAY_LIS)
      );Setq
    )
  )
)


; ********** Info aus der "Farbe" Dialogbox holen **********
(Defun DDCOLORSTART (/ NFARBE)
  (If (Or (= (Getvar "cecolor") "BYLAYER")
	  (= (Getvar "cecolor") "VONLAYER")
	  (= (Getvar "cecolor") "256")
      );Or
    (Setq NFARBE (Acad_Colordlg 255 1))
    (Setq NFARBE (Acad_Colordlg (Atoi FARBE) 1))
  );If

  (If (= NFARBE 256)
    (Setvar "cecolor" "256")
    (Setvar "cecolor" (Itoa NFARBE))
  );If

  (Setq FARBE (Itoa NFARBE))
  (C:POSNRWP)
)





; --------------- NEUER BEREICH -----------------------    

; ********** Info aus der "Linientyp" Dialogbox holen **********
(Defun DDLTYPESTART (/ NLTYP)
  (initdia)(command "_linetype")
  (Setq NLTYP (Getvar "celtype"))
  (Setq LTYPE (Getvar "celtype"))	;HIER WEITERMACEN
  (C:POSNRWP)
)

; --------------- ENDE NEUER BEREICH -----------------------    





; ********** Farbeinstellung wir geprft **********
(Defun PRFE_FARBE (/)
  (Setq FARBE (Atoi $VALUE))
  (If (Or (< FARBE 0) (> FARBE 256))
    (Princ "\nFarbwert nicht zulssig")
    (Progn (Setq FARBE (Itoa FARBE)) (Setvar "cecolor" FARBE) (FARBZEIG))
  )
)


; ********** Linientypeinstellung wir geprft **********
(Defun PRFE_LTYP (/)
  (Setq LTYP (Atoi $VALUE))
  (If (Or (< LTYP 0) (> LTYP 256))
    (Princ "\nLinientyp nicht zulssig")
    (Progn (Setq LTYP (Itoa LTYP)) (Setvar "celtype" LTYP) (LTYPZEIG))
  )
)


; ********** Funktion (DCL) fr Farbe wird gestartet  **********
(Defun FARBZEIG	(/ V1 V2)
  (Setq	V1 (Dimx_Tile "color")
	V2 (Dimy_Tile "color")
  )
  (Start_Image "color")
  (Fill_Image 0 0 V1 V2 (Atoi (Getvar "cecolor")))
  (End_Image)
)


; ********** Funktion (DCL) fr Linientyp wird gestartet  **********
(Defun LTYPZEIG	(/ V1 V2)
  (Setq	V1 (Dimx_Tile "linetype")
	V2 (Dimy_Tile "linetype")
  )
  (Start_Image "linetype")
  (Fill_Image 0 0 V1 V2 (Atoi (Getvar "celtype")))
  (End_Image)
)


; **********  **********
(DEFUN BM (GRAD / GRAD)
  (* PI (/ GRAD 180.0))
) ;_ Ende von defun


; **********  **********
(PROMPT "\nPositionsnummern geladen.")
(PROMPT "\nStart mit -----> POSNR")
(PRINC)